function  unwph = zstep(wph)
%         unwph = zstep(wph);
%
%MATLAB 5.x
%
%Implements  Z step of the zpim algoritm with  discontinuities and 
%without mask.
%(see ieeetip, vol 11, no. 4, pp. 408-422, 2002)
%
%============================================================
%Input parameters
%
%wph	-> wrapped phase matrix (DATATYPE - double)
%
%============================================================
%Output  parameters
%
%unwph	-> unwrapped phase matrix (DATATYPE - double)
%
%
%
%   Author J.M. Bioucas Dias, 2003
% 
%   Topic -  Interferometry


[M N] =size(wph);

disc=dbuild(zeros(M,N),zeros(M,N));
unwph= double(zs(single(wph),single(disc)));




